// Generated by LiveScript 1.3.1
var fs, fw, path, pack, utils, unpack, create, download, arrayUnique, resolveTree, ncp, exec, EventEmitter, ref$, dirname, join, basename, relative, rm, mk, isWin, tmpdir, copyBinary, rename, exists, once, isFile, extend, handleExit, arch, discoverPkg, resolvePkgPath, script, supportedPlatforms, supportedArchs, supportedVersions, copyOpts, apply, findIndex, matchVersion, sameNodeBinary, setOs, setArch, setNode;
fs = require('fs');
fw = require('fw');
path = require('path');
pack = require('./pack');
utils = require('./utils');
unpack = require('./unpack');
create = require('./create');
download = require('./download');
arrayUnique = require('array-unique');
resolveTree = require('resolve-tree');
ncp = require('ncp').ncp;
exec = require('child_process').exec;
EventEmitter = require('events').EventEmitter;
ref$ = require('path'), dirname = ref$.dirname, join = ref$.join, basename = ref$.basename, relative = ref$.relative;
rm = utils.rm, mk = utils.mk, isWin = utils.isWin, tmpdir = utils.tmpdir, copyBinary = utils.copyBinary, rename = utils.rename, exists = utils.exists, once = utils.once, isFile = utils.isFile, extend = utils.extend, handleExit = utils.handleExit, arch = utils.arch, discoverPkg = utils.discoverPkg, resolvePkgPath = utils.resolvePkgPath;
script = join(__dirname, '..', 'scripts/run.sh');
supportedPlatforms = ['linux', 'darwin', 'sunos'];
supportedArchs = ['x86', 'x64', 'armv7l'];
supportedVersions = [/^0.(8|9|10|11|12).[0-9]+$/, /^[0-9].[0-9].[0-9]+$/];
copyOpts = {
  stopOnErr: false,
  clobber: true
};
module.exports = function(options){
  var emitter, dest, tmpPath, tmpDownload, nodeBinary, clean, onError, onDownloadError, onEntry, onEnd, onCreateEnd, onProgress, onDownload, onDownloadEnd, getBinaryType, createExecutable;
  emitter = new EventEmitter;
  options = apply(
  options);
  dest = options.dest || process.cwd();
  tmpPath = tmpdir();
  tmpDownload = null;
  options.dest = tmpPath;
  nodeBinary = null;
  clean = function(){
    emitter.emit('message', 'Cleaning temporary directories');
    try {
      rm(
      tmpPath);
      if (tmpDownload) {
        return rm(
        tmpDownload);
      }
    } catch (e$) {}
  };
  onError = once(function(err){
    clean();
    return emitter.emit('error', err);
  });
  onDownloadError = function(err){
    return onError(
    err);
  };
  onEntry = function(it){
    if (it) {
      return emitter.emit('entry', it);
    }
  };
  onEnd = function(it){
    clean();
    return emitter.emit('end', it);
  };
  onCreateEnd = function(narPath){
    return createExecutable(
    narPath);
  };
  onProgress = function(status){
    return emitter.emit('progress', status);
  };
  onDownload = function(){
    return emitter.emit(
    'download');
  };
  onDownloadEnd = function(it){
    return emitter.emit('downloadEnd', it);
  };
  getBinaryType = function(){
    var os, arch;
    os = options.os, arch = options.arch;
    return os + "-" + arch;
  };
  createExecutable = function(nar){
    var narFile, narPath, narOutput, cleanExec, copyNodeBinary, copyDirectory, copyNarPkg, createTarball, createBinary, generate, extractBinary, getDownloadUrl, downloadBinary;
    narFile = basename(nar, '.nar');
    narPath = join(dest, narFile) + '.run';
    narOutput = join(dest, narFile) + ("-" + getBinaryType() + ".nar");
    cleanExec = function(){
      rm(
      narPath);
      return clean();
    };
    copyNodeBinary = function(done){
      var binDir;
      binDir = join(tmpPath, 'bin');
      mk(
      binDir);
      return copyBinary(nodeBinary || process.execPath, binDir, done);
    };
    copyDirectory = function(dest){
      return function(dir, next){
        var name, orig, pkgDest;
        name = basename(
        dir);
        orig = join(dest, name);
        pkgDest = join(dest, name);
        return fs.exists(orig, function(exists){
          if (exists) {
            return next();
          }
          return fs.exists(pkgDest, function(exists){
            if (exists) {
              return next();
            }
            mk(
            pkgDest);
            return ncp(dir, pkgDest, copyOpts, next);
          });
        });
      };
    };
    copyNarPkg = function(done){
      var narDest, narPath, narManifest, doCopy;
      narDest = join(tmpPath, 'nar');
      narPath = join(__dirname, '..');
      narManifest = require(join(narPath, 'package.json'));
      doCopy = function(paths, done){
        return ncp(narPath, narDest, copyOpts, function(err){
          var depsDest;
          if (err) {
            return done(
            err);
          }
          depsDest = join(narDest, 'node_modules');
          return fw.each(paths, copyDirectory(
          depsDest), done);
        });
      };
      return resolveTree.manifest(narManifest, {
        basedir: narPath
      }, function(err, tree){
        var paths, rootPaths, parentPaths;
        if (err) {
          return cb(err);
        }
        paths = arrayUnique(
        resolveTree.flattenMap(tree, 'root'));
        rootPaths = paths.filter(function(it){
          return join(options.base, 'node_modules', basename(it)) === it;
        });
        parentPaths = arrayUnique(
        paths.filter(function(it){
          return rootPaths.indexOf(
          it) === -1;
        }).filter(function(it){
          return new RegExp("^" + narPath).test(it) === false;
        }).map(function(it){
          return relative(join(options.base, 'node_modules'), it).split('/').shift();
        }).map(function(it){
          return join(options.base, 'node_modules', it);
        }).filter(function(it){
          return rootPaths.indexOf(
          it) === -1;
        }));
        return doCopy(rootPaths.concat(parentPaths), done);
      });
    };
    createTarball = function(done){
      var config;
      config = {
        name: basename(nar, '.nar'),
        dest: dest,
        patterns: ['**'],
        src: tmpPath,
        ext: 'run',
        gzip: true
      };
      return pack(
      config).on('error', done).on('entry', onEntry).on('end', function(){
        return done();
      });
    };
    createBinary = function(done){
      var cmd;
      cmd = isWin ? 'type' : 'cat';
      return exec(cmd + " \"" + script + "\" \"" + narPath + "\" > \"" + narOutput + "\"", done);
    };
    generate = function(){
      emitter.emit(
      'generate');
      return fw.parallel([copyNodeBinary, copyNarPkg], function(err){
        if (err) {
          return onError(
          new Error('cannot copy files to temporal directory: ' + err));
        }
        return fw.series([createTarball, createBinary], function(err){
          if (err) {
            return onError(
            new Error("cannot create the executable due to error: " + (err.messsage || err)));
          }
          cleanExec();
          return emitter.emit('end', narOutput);
        });
      });
    };
    extractBinary = function(options){
      options.gzip = true;
      return unpack(
      options).on('error', onError).on('end', function(){
        nodeBinary = join(options.dest, options.name, 'bin', 'node');
        return generate();
      });
    };
    getDownloadUrl = function(engine){
      engine = engine === 'node' ? 'nodejs' : engine;
      return "https://" + engine + ".org/dist";
    };
    downloadBinary = function(){
      var node, io, engine, version, name, url, dest;
      node = options.node, io = options.io;
      engine = io ? 'iojs' : 'node';
      version = io || node;
      name = engine + "-" + version + "-" + getBinaryType();
      url = getDownloadUrl(
      engine) + "/" + version + "/" + name + ".tar.gz";
      dest = tmpDownload = tmpdir();
      return download(
      {
        url: url,
        dest: dest,
        proxy: options.proxy
      }).on('download', onDownload).on('progress', onProgress).on('error', onDownloadError).on('end', function(it){
        onDownloadEnd(
        it);
        return extractBinary(
        {
          path: it,
          dest: dest,
          name: name
        });
      });
    };
    if (!sameNodeBinary(
    options)) {
      return downloadBinary();
    } else {
      return generate();
    }
  };
  if (isWin && options.os === 'win32') {
    return onError(
    new Error('Windows do not support nar executables. Use --os <linux|darwin|sunos>'));
  }
  mk(tmpPath);
  handleExit(
  clean);
  create(
  options).on('error', onError).on('entry', onEntry).on('end', onCreateEnd).on('start', function(){
    return emitter.emit(
    'start');
  }).on('archive', function(it){
    return emitter.emit('archive', it);
  });
  return emitter;
};
apply = function(options){
  var pkgPath;
  setOs(
  options);
  setArch(
  options);
  setNode(
  options);
  options.executable = true;
  if (options.path) {
    pkgPath = resolvePkgPath(
    options.path);
  } else {
    pkgPath = process.cwd();
  }
  options.path = discoverPkg(
  pkgPath);
  if (/\.json$/i.test(pkgPath)) {
    options.base = dirname(
    pkgPath);
  } else {
    options.base = pkgPath;
  }
  return options;
};
findIndex = function(arr, item){
  return arr.indexOf(item) !== -1;
};
matchVersion = function(version){
  return supportedVersions.filter(function(it){
    return it.test(version);
  }).length !== 0;
};
sameNodeBinary = function(options){
  var os, arch, node, io;
  os = options.os, arch = options.arch, node = options.node, io = options.io;
  if (io) {
    node = io;
  }
  return os === process.platform && arch === process.arch && node === process.version;
};
setOs = function(options){
  var os;
  os = options.os;
  if (os) {
    if (findIndex(supportedPlatforms, os)) {
      return options.os = os, options;
    } else {
      throw new Error("Invalid OS platform '" + os + "'. Only " + supportedPlatforms.join(', ') + " are supported");
    }
  } else {
    return options.os = process.platform, options;
  }
};
setArch = function(options){
  var arch;
  arch = options.arch;
  if (arch) {
    if (findIndex(supportedArchs, arch)) {
      return options.arch = arch, options;
    } else {
      throw new Error("Invalid architecture '" + arch + "'. Only x86, x64 and armv7l are supported");
    }
  } else {
    return options.arch = process.arch, options;
  }
};
setNode = function(options){
  var node, io;
  node = options.node, io = options.io;
  if (node) {
    if (node === 'latest') {
      return options.node = 'latest', options;
    } else if (matchVersion(
    node)) {
      return options.node = "v" + node, options;
    } else {
      throw new Error("Invalid node version '" + node + "'");
    }
  } else if (io) {
    if (io === 'latest') {
      return options.io = 'latest', options;
    } else if (matchVersion(
    io)) {
      return options.io = "v" + io, options;
    } else {
      throw new Error("Invalid io.js version '" + io + "'");
    }
  } else {
    return options.node = process.version, options;
  }
};
